unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, OpenGLContext, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, gl, glu;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    OpenGLControl1: TOpenGLControl;
    Timer1: TTimer;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenGLControl1MouseWheelDown(Sender: TObject);
    procedure OpenGLControl1MouseWheelUp(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  Width : Integer = 584;
  Height : Integer = 680;
  zoom : Integer = 27;
  zoom_speed : Integer = 1;
  zoom_Max : Integer = 80;
  zoom_Min : Integer = 5;
  angleX: double = -30;
  angleY: double = -20;
  distZ: double = -5;
const
  SIZE = 1;
  light_ambient : Array [0..3] of GLfloat = (0.0, 0.0, 0.0, 1.0 );
  light_diffuse : Array [0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0 );
  light_specular : Array [0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0 );
  light_position : Array [0..3] of GLfloat = (2.0, 2.0, 2.0, 0.0 );
  mat1_amb : Array [0..3] of GLfloat = (0.2, 0.2, 0.2, 1.0  );
  mat1_dif : Array [0..3] of GLfloat = (0.8, 0.8, 0.8, 1.0 );
  mat1_spec : Array [0..3] of GLfloat = (0.0, 0.0, 0.0, 1.0 );
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  close
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

end;

procedure TForm1.OpenGLControl1MouseWheelDown(Sender: TObject);
begin
  if zoom <= zoom_Max then
      zoom := zoom + zoom_speed;
end;

procedure TForm1.OpenGLControl1MouseWheelUp(Sender: TObject);
begin
  if zoom >= zoom_Min then
      zoom := zoom - zoom_speed;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  glClearColor (0.11, 0.55, 0.93, 1);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glViewport (0, 0, Width, Height);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity();
  gluPerspective (zoom, Width/ Height, 0.01, 1000);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(
  0.0, 0.0, 5, // положение камеры
  0.0, 0.0, 0.0, // центр сцены
  0.0, 1.0, 0.0); // положительное направление оси y

  glPushMatrix();
  glTranslatef(-1.0, 0.0, distZ);
  glRotatef(angleY, -1.0, 0.0, 0.0);
  glRotatef(angleX, 0.0, 1.0, 0.0);

glEnable(GL_DEPTH_TEST);

glEnable(GL_LIGHT0);
glEnable(GL_LIGHTING);
glLightfv(GL_LIGHT0, GL_AMBIENT, @light_ambient);
glLightfv(GL_LIGHT0, GL_DIFFUSE, @light_diffuse);
glLightfv(GL_LIGHT0, GL_SPECULAR, @light_specular);
glLightfv(GL_LIGHT0, GL_POSITION, @light_position);

glEnable(GL_COLOR_MATERIAL);
glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, @mat1_amb);
glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, @mat1_spec);
glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, @mat1_dif);
  glBegin(GL_QUADS);
    glNormal3f(0,0,1);
    glTexCoord2f(0,0); glVertex3f(-SIZE,-SIZE, SIZE);
    glTexCoord2f(1,0); glVertex3f( SIZE,-SIZE, SIZE);
    glTexCoord2f(1,1); glVertex3f( SIZE, SIZE, SIZE);
    glTexCoord2f(0,1); glVertex3f(-SIZE, SIZE, SIZE);

    glNormal3f(0,0,-1);
    glTexCoord2f(0,1); glVertex3f(-SIZE, SIZE,-SIZE);
    glTexCoord2f(1,1); glVertex3f( SIZE, SIZE,-SIZE);
    glTexCoord2f(1,0); glVertex3f( SIZE,-SIZE,-SIZE);
    glTexCoord2f(0,0); glVertex3f(-SIZE,-SIZE,-SIZE);

    glNormal3f(1,0,0);
    glTexCoord2f(0,1); glVertex3f( SIZE, SIZE,-SIZE);
    glTexCoord2f(1,1); glVertex3f( SIZE, SIZE, SIZE);
    glTexCoord2f(1,0); glVertex3f( SIZE,-SIZE, SIZE);
    glTexCoord2f(0,0); glVertex3f( SIZE,-SIZE,-SIZE);

    glNormal3f(-1,0,0);
    glTexCoord2f(0,0); glVertex3f(-SIZE,-SIZE,-SIZE);
    glTexCoord2f(1,0); glVertex3f(-SIZE,-SIZE, SIZE);
    glTexCoord2f(1,1); glVertex3f(-SIZE, SIZE, SIZE);
    glTexCoord2f(0,1); glVertex3f(-SIZE, SIZE,-SIZE);

    glNormal3f(0,1,0);
    glTexCoord2f(0,0); glVertex3f(-SIZE, SIZE,-SIZE);
    glTexCoord2f(1,0); glVertex3f(-SIZE, SIZE, SIZE);
    glTexCoord2f(1,1); glVertex3f( SIZE, SIZE, SIZE);
    glTexCoord2f(0,1); glVertex3f( SIZE, SIZE,-SIZE);

    glNormal3f(0,-1,0);
    glTexCoord2f(0,1); glVertex3f( SIZE,-SIZE,-SIZE);
    glTexCoord2f(1,1); glVertex3f( SIZE,-SIZE, SIZE);
    glTexCoord2f(1,0); glVertex3f(-SIZE,-SIZE, SIZE);
    glTexCoord2f(0,0); glVertex3f(-SIZE,-SIZE,-SIZE);
  glEnd;
  glPopMatrix();
  glFlush();
OpenGLControl1.SwapBuffers;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   Label5.Caption := inttostr(TrackBar1.Position);
   TrackBar1.SelEnd := TrackBar1.Position;
   zoom_speed := TrackBar1.Position;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  Label2.Caption := inttostr(TrackBar2.Position);
   TrackBar2.SelEnd := TrackBar2.Position;
   zoom := TrackBar2.Position;
end;

end.

